'*******************************************************************************
'	Filename		: count_words.vbs

'	Description		: Counts the number of words in the selected text of the 
' 					  active document.

'	Created			: 28 September 2006
'	Created by		: James Swan
 
'	Note			: Since this script uses Regular Expressions to extract the
'					  word count, VBScript version 5 is needed to run it. 
'					  This is the version of the VBScript scripting engine 
'					  released with Internet Explorer 5.
' 					  This script has only been tested on Windows 2000 and XP

'	You may distribute this script freely, but please keep this header intact.
'*******************************************************************************
Option Explicit

Const MODULE_NAME = "CountWordsRegExp"
Const MODULE_VER = "0.1"
Const MODULE_TITLE = "Count Words"

Sub Init
    addMenuItem MODULE_TITLE, "Utilities", MODULE_NAME
End Sub

Sub CountWordsRegExp()
	Dim editor, re
	Dim i, intWordCount
	Dim strInput
	Const vbExclamation = 48
	Const vbInformation = 64

	Set editor = newEditor()

	With editor
		.assignActiveEditor()
		strInput = .selText()
	End With

	If Len(strInput) > 0 Then
		
		Set re = New RegExp
		    With re
			    .Pattern = "\b\w+\b"
			    .Global = True
			    intWordCount = .Execute(strInput).Count
			End With
		Set re = Nothing

	    MsgBox "The selection is " & intWordCount & " words long.", vbInformation, MODULE_TITLE
	    
	Else
		MsgBox "Please select some text...  ", vbExclamation, MODULE_TITLE
	End If

	Set editor = Nothing

End Sub
